/* enemy.c */

#include <stdio.h>
#include <xsp2lib.h>

#include "main.h"
#include "player.h"
#include "enemy.h"
#include "shot.h"

#define ENEMY_MAX	32	/* Gő吔 */

static ENEMY enemy[ENEMY_MAX];	/* [N */
static ENEMY *enemy_top,	/* gp̃[ÑXg */
 *enemy_null_top,		/* ̃[ÑXg */
 *enemy_end;			/* gp[ÑXg̖ */



/* ֐ւ̃|C^̔z */
typedef void (*enemy_alloc) (ENEMY *);
enemy_alloc EnemyAllocFunc[] =
{
	EnemyAllocZakoA,
	EnemyAllocZakoB,
	EnemyAllocCoverN,
	EnemyAllocOplaser,
};


 /* Q[JnɌĂ΂ */
void EnemyInit (void)
{
	int i;

    /* XgȂ */
	enemy_top = NULL;
	enemy_end = NULL;
	enemy_null_top = enemy;
	for (i = 0; i < ENEMY_MAX; i++)
		enemy[i].next = &enemy[i + 1];

	enemy[ENEMY_MAX - 1].next = NULL;
}



/* GoɌĂ΂ */
ENEMY *EnemyAlloc (short type, signed short x, signed short y)
{
	ENEMY *p;

	if (enemy_null_top == NULL)
		return (NULL);	/* 󂫂̃[NȂiLN^[I[o[j */

    /* Xg̖ɐVm[hǉiƂ͈Ⴄ̂ŒӁj */
	p = enemy_null_top;
	enemy_null_top = p->next;
	if (enemy_top == NULL)
		enemy_top = p;
	else
		enemy_end->next = p;
	p->next = NULL;
	enemy_end = p;

	p->type = type;
	p->lx = x << 16;
	p->ly = y << 16;
	p->shot = NULL;

    /* ֐ւ̃|C^gĕ */
    /* type  0 Ȃ EnemyAllocA() A1 Ȃ EnemyAllocB() s */
	EnemyAllocFunc[p->type] (p);

	return (p);
}



/* ƂɌĂ΂ */
void EnemyMove (void)
{
	ENEMY *p, *q;
	signed short pl_x = player->x, pl_y = player->y;

	p = enemy_top;		/* ݒڂĂ郏[N */
	q = NULL;		/* PÕ[Ni[N폜ɕKvj */
	while (p != NULL) {
	    /* GL̈ړ[` */

	    /* ֐ւ̃|C^gĕ */
	    /* iFuncEnemy/ ȉ FuncMoveXXX() Ăłj */
		if ((p->func_enemy_move) (p)) {		/* ԂlOȂ */
			(p->func_enemy_free) (p);	/* ֐Ă */
			if (q == NULL) {	/* Xg̈ԍŏ폜 */
				enemy_top = p->next;
				p->next = enemy_null_top;
				enemy_null_top = p;
				q = NULL;
				p = enemy_top;
			} else {
				if (p == enemy_end) {	/* Xg̈ԍŌ폜 */
					q->next = NULL;
					enemy_end = q;
					p->next = enemy_null_top;
					enemy_null_top = p;
					p = q->next;
				} else {
					q->next = p->next;
					p->next = enemy_null_top;
					enemy_null_top = p;
					p = q->next;
				}
			}
		} else {
		    /* GLȂꍇ */
			SHOT *p2 = shot;	/* ݒڂĂVbg̃[N */
			signed short t;

		    /* vC[Ƃ̓蔻 */
			if (((t = p->x + p->hit_sx) > pl_x)
			    && ((t -= (short) (p->hit_sx << 1)) < pl_x)
			    && ((t = p->y + p->hit_sy) > pl_y)
			    && ((t -= (short) (p->hit_sy << 1)) < pl_y)) {
			    /*  */
				if ((player->status == PLAYER_STATUS_ALIVE) && (player->muteki == 0))
					player->status = PLAYER_STATUS_DEAD;
			}
		    /* VbgƂ̓蔻 */
			if (p2->status != SHOT_STATUS_NON) {
				signed short p2_w;
				short hit_w;
				if (((t = p->x + (hit_w = p->hit_sx)) >= (p2_w = *((short *) (&p2->lx))))
				    && ((t -= (short) (hit_w << 1)) <= p2_w)
				    && ((t = p->y + (hit_w = p->hit_sy)) >= (p2_w = *((short *) (&p2->ly))))
				    && ((t -= (short) (hit_w << 1)) <= p2_w)) {

					p->damage++;	/* GLɃ_[W^ */
				    /* Vbg */
					if (p->damage_mode == DAMAGE_THROUGH) {
					    /* VbgђʂG̏ꍇ */
						p->shot_count = p2->shot_count;
						if (p2->shot_count < 3)
							p2->shot_count++;
					} else {
					    /* VbghG̏ꍇ */
						if (p2->enemy == NULL) {
						    /* ɎhĂȂ */
							if (p2->shot_count < 3)
								p2->shot_count++;
							p2->status = SHOT_STATUS_STICK;
							p2->enemy = p;
							p2->off_x = p2->x - p->x;
							p2->off_y = p2->y - p->y;
							p->shot = p2;
						}
					}
				}
			}
			q = p;
			p = p->next;
		}
	}
}
