/* eshot.c */

#include <stdio.h>
#include <xsp2lib.h>

#include "main.h"
#include "player.h"
#include "eshot.h"

#define	PALET_ESHOT	0x0300

#define ESHOT_MAX	200	/* Geő吔 */
static ESHOT eshot[ESHOT_MAX];	/* [N */



/* Q[JnɌĂ΂ */
void EshotInit (void)
{
	int i;

    /* XgȂ */
	eshot_top = NULL;
	eshot_null_top = eshot;
	for (i = 0; i < ESHOT_MAX; i++)
		eshot[i].next = &eshot[i + 1];

	eshot[ESHOT_MAX - 1].next = NULL;
}



/* GeoɌĂ΂ */
void EshotAlloc (short type, signed short x, signed short y, unsigned char speed, unsigned char angle, signed short t)
{
	ESHOT *p;

	if (eshot_null_top == NULL)	/* [N̋󂫂͂邩H */
		return;

	p = eshot_null_top;
	eshot_null_top = p->next;
	p->next = eshot_top;
	eshot_top = p;

	p->lx = (x - 8) << 16;	/* (8,8) XvCgW̒SȂ̂ŕ␳ */
	p->ly = (y - 8) << 16;
	p->vx = xytable[speed][angle].x;
	p->vy = xytable[speed][angle].y;
	if (t) {		/* t t[̒ll */
		p->lx += (p->vx * t);
		p->ly += (p->vy * t);
	}
    /* FGȇxƓ蔻̑傫ɂ */
    /* eshot->hx ȉ̏ꍇAeshot->vx ̍ől͈ȉ̒ʂ */
    /* (hx,vx ) = (2,1.0),(3,3.0),(4,5.0),(5,7.0),(6,9.0) */
    /* Zo͈ȉ̒ʂ */
    /* eshot->vx+player->vx > 2*eshot->hx ̎蔲 */
    /* player->vx ̍ől 3.0iړj */

	switch (p->type = type) {
	case ESHOT_NRG01:	/* GlM[eiɏj */
		p->hit_p = 2;	/* x 1.0 ɂ鎖 */
		p->pt = sp_eshot + type;
		p->info = PALET_ESHOT | PRIORITY_ESHOT;
		break;

	case ESHOT_NRG02:	/* @@ V @@ij */
	case ESHOT_NRG03:	/* @@ V @@ij */
	case ESHOT_NRG04:	/* @@ V @@ij */
		p->hit_p = 3;	/* x 3.0 ɂ鎖 */
		p->pt = sp_eshot + type;
		p->info = PALET_ESHOT | PRIORITY_ESHOT;
		break;

	case ESHOT_NRG05:	/* @@ V @@ij */
	case ESHOT_NRG06:	/* @@ V @@ij */
	case ESHOT_NRG22:	/* @@ V @@iɂQj */
	case ESHOT_NRG32:	/* @@ V @@iɂQj */
	case ESHOT_NRG23:	/* @@ V @@iRp`ɂRj */
	case ESHOT_NRG24:	/* @@ V @@i`ɂSj */
	case ESHOT_NRG14N:	/* @@ V @@i΂߂ɂSj */
	case ESHOT_NRG24N:	/* @@ V @@i΂߂ɂSj */
	case ESHOT_NRG34N:	/* @@ V @@i΂߂ɂSj */
	case ESHOT_NRG34:	/* @@ V @@i`ɂSj */
	case ESHOT_NRG15:	/* @@ V @@iTj */
	case ESHOT_NRG35:	/* @@ V @@iƑ吳`ɂTj */
		p->hit_p = 4;	/* x 5.0 ɂ鎖 */
		p->pt = sp_eshot + type;
		p->info = PALET_ESHOT | PRIORITY_ESHOT;
		break;
#if	0
	case ESHOT_LASER01:
		p->hit_p = 3;	/* x 3.0 ɂ鎖 */
		p->pt = sp_laser + 8;
		p->info = PALET_ESHOT | PRIORITY_ESHOT;
		break;

	case ESHOT_LASEREX:
		p->hit_p = 4;	/* x 5.0 ɂ鎖 */
		p->pt = sp_laser + 9;
		p->info = PALET_ESHOT | PRIORITY_ESHOT;
		break;
#endif
	default:
		break;
	}

}



/* ƂɌĂ΂ */
void EshotMove (void)
{
	ESHOT *p, *q;
	signed short pl_x = player->x - 8, pl_y = player->y - 8;

#ifdef DEBUG
	eshot_sum = 0;
#endif
	p = eshot_top;		/* ݒڂĂ郏[N */
	q = NULL;		/* PÕ[Ni[N폜ɕKvj */

	while (p != NULL) {
		signed short p_x, p_y;

#ifdef DEBUG
		eshot_sum++;
#endif
	    /* x𑫂ďʃ[hiŒ萮jo */
		p_x = p->x = (p->lx += p->vx) >> 16;
		p_y = p->y = (p->ly += p->vy) >> 16;

	    /* GeʊOɏoH */
	    /* iʉEoƍoP̔rōsĂj */
		if (((unsigned short) p_x > 256 + 16) || ((unsigned short) p_y > 256 + 16)) {
		    /* GeʊO֏ôŏ */
			if (q == NULL) {	/* Xg̈ԍŏ폜 */
				eshot_top = p->next;
				p->next = eshot_null_top;
				eshot_null_top = p;
				q = NULL;
				p = eshot_top;
			} else {
				q->next = p->next;
				p->next = eshot_null_top;
				eshot_null_top = p;
				p = q->next;
			}
		} else {
		    /* ʊO֏oĂȂ */

		    /* GeƎ@̓蔻 */
		    /* ̕ӂ̍œK -fstrings-reduce 撣ĂnY */
			signed short t, t2 = p->hit_p;
			if (((t = p_y - t2) <= pl_y)
			    && ((t += (short) (t2 << 1)) >= pl_y)
			    && ((t = p_x + t2) >= pl_x)
			    && ((t -= (short) (t2 << 1)) <= pl_x)) {
				if ((player->status == PLAYER_STATUS_ALIVE) && (player->muteki == 0))
					player->status = PLAYER_STATUS_DEAD;
			} else {
				xsp_set_st (p);
			}

			q = p;
			p = p->next;
		}
	}
}
