/* player.c */

#include <sys/iocs.h>
#include <xsp2lib.h>

#include "main.h"
#include "player.h"
#include "shot.h"
#include "effect.h"
#include "sound.h"

#define PLAYER_BANK1	8	/* Xp^[ֈڍs܂ł̒l */
#define PLAYER_BANK2	12	/* ԌXp^[ֈȉ */

#define PLAYER_SPEED	15	/* @̑x */
#define PLAYER_PALET	0x0700	/* @̃pbg */

#define PLAYER_START_X	144	/* @o̍W */
#define PLAYER_START_Y	(256+32)

#define PLAYER_MINX		(16+8)	/* X Wŏl */
#define PLAYER_MAXX		(16+255-8)
#define PLAYER_MINY		(16+16)		/* Y Wŏl */
#define PLAYER_MAXY		(16+255-12)

#define	TIME_MUTEKI	90	/* oꎞ̖G */

enum {
	PLAYER_PT_RIGHT2 = 0,	/* @ԉEɌXĂ鎞̃p^[ */
	PLAYER_PT_RIGHT1,	/* @V@EɁ@@@@@V@@@@@ */
	PLAYER_PT_CENTER,	/* @V@ʂĂ鎞̃p^[ */
	PLAYER_PT_LEFT1,	/* @EɌXĂ鎞̃p^[ */
	PLAYER_PT_LEFT2		/* @V@ԉEɁ@@@@@V@@@@@ */
};



/* Q[JnɌĂ΂ */
void PlayerInit (void)
{
}



/* vC[oɌĂ΂ */
void PlayerAlloc (void)
{
	player->lx = PLAYER_START_X * 65536;
	player->ly = PLAYER_START_Y * 65536;
	player->status = PLAYER_STATUS_APPEAR;	/* oԂ */
	player->counter = 0;
	player->muteki = TIME_MUTEKI;
	player->flash = 0;
}



/* @Ă鎞̈ړ */
static void PlayerMoveAlive (void)
{
	int j;			/* WCXeBbN̓ */

	j = _iocs_joyget (0);	/* WCXeBbNO */

    /* [A] {^ꂽH */
	if ((j & 0b00100000) == 0)
		game_over = !0;	/* Q[I[o[ */

    /* [B] {^ꂽH */
	if ((j & 0b1000000) == 0)
		ShotAlloc ();

    /* @̏㉺ړ */
	switch (j & 0b0011) {
	case 0b0010:		/*  */
		if (player->ly >> 16 > PLAYER_MINY)
			player->ly += xytable[PLAYER_SPEED][192].y;
		break;
	case 0b0001:		/*  */
		if (player->ly >> 16 < PLAYER_MAXY)
			player->ly += xytable[PLAYER_SPEED][64].y;
		break;
	default:		/* ȊO */
		break;
	}

    /* @̍Eړ{EX */
	switch (j & 0b1100) {
	case 0b1000:		/*  */
		if (player->lx >> 16 > PLAYER_MINX)
			player->lx += xytable[PLAYER_SPEED][128].x;
		if (player->bank > 0) {
			player->bank = 0;
		} else {
			if (player->bank > -PLAYER_BANK2)
				player->bank--;
		}
		break;

	case 0b0100:		/* E */
		if (player->lx >> 16 < PLAYER_MAXX)
			player->lx += xytable[PLAYER_SPEED][0].x;
		if (player->bank < 0) {
			player->bank = 0;
		} else {
			if (player->bank < PLAYER_BANK2)
				player->bank++;
		}
		break;

	default:		/* ȊO */
	    /* @̌Xɖ߂ */
		if (player->bank != 0) {
			if (player->bank > 0)
				player->bank--;
			else
				player->bank++;
		}
		break;
	}

    /* @̌X (player->bank) 玩@̕XvCgNo.߂ */
	if (player->bank == 0) {
		player->pt = obj_player + PLAYER_PT_CENTER;
	} else {
		if (player->bank > 0) {
			if (player->bank < PLAYER_BANK1)
				player->pt = obj_player + PLAYER_PT_LEFT1;
			else
				player->pt = obj_player + PLAYER_PT_LEFT2;
		} else {
			if (player->bank > -PLAYER_BANK1)
				player->pt = obj_player + PLAYER_PT_RIGHT1;
			else
				player->pt = obj_player + PLAYER_PT_RIGHT2;
		}
	}

	player->x = player->lx / 65536;
	player->y = player->ly / 65536;

    /* GԂ̏ */
	player->info = PALET_PLAYER | PRIORITY_PLAYER;
	if (player->muteki) {
		player->muteki--;
		player->flash++;
		if (player->muteki > 55) {
		    /* oARcĂ̂őtbV */
			if (player->flash > 1) {
				player->info = PALET_PLAYER_FLASH | PRIORITY_PLAYER;
				player->flash = 0;
			}
		} else {
		    /* oAȂ̂ŒxtbV */
			if (player->flash > 5)
				player->info = PALET_PLAYER_FLASH | PRIORITY_PLAYER;
			if (player->flash > 10)
				player->flash = 0;
		}
	}
	xobj_set_st (player);	/* @\ */
}


/* @񂾎̈ړ */
static void PlayerMoveDead (void)
{
    /* @̌Xɖ߂ */
	if (player->bank != 0) {
		if (player->bank > 0)
			player->bank--;
		else
			player->bank++;
	}
    /* @̌X (player->bank) 玩@̕XvCgNo.߂ */
	if (player->bank == 0) {
		player->pt = obj_player + PLAYER_PT_CENTER;
	} else {
		if (player->bank > 0) {
			if (player->bank < PLAYER_BANK1)
				player->pt = obj_player + PLAYER_PT_LEFT1;
			else
				player->pt = obj_player + PLAYER_PT_LEFT2;
		} else {
			if (player->bank > -PLAYER_BANK1)
				player->pt = obj_player + PLAYER_PT_RIGHT1;
			else
				player->pt = obj_player + PLAYER_PT_RIGHT2;
		}
	}

	player->info = PALET_PLAYER | PRIORITY_PLAYER;
	switch (player->counter++) {
	case 0:
	    /* 񂾂ƂȂ甚p^[o */
		EffectAlloc (EFFECT_EXPLPLAYER, 0, player->x, player->y);	/* p^[o */
		SoundSetSE (SE_PLAYER_EXPL);	/* vC[̔ */
		break;
	case 8 * 1:
	case 8 * 2:
	case 8 * 3:
	case 8 * 4:
	case 8 * 5:
		{
			signed short x, y;
			x = rndtable[(player->counter) & 0xff ^ 0x55] - 128;
			y = rndtable[(player->counter + 1) & 0xff ^ 0xaa] - 128;
		    /* player->counter ͗̎ƂĎgpĂ܂ */
			EffectAlloc (EFFECT_EXPLPLAYER, 0, player->x + x / 8, player->y + y / 8);
			SoundSetSE (SE_PLAYER_EXPL);	/* vC[̔ */
		}
		break;

	case 8 * 7:
	    /* Ṓuǂ[v */
		EffectAlloc (EFFECT_EXPLPLAYER, 0, player->x, player->y);
		SoundSetSE (SE_EXPL_L);
		player->x = 256 + 32;
		player->y = 256 + 32;
		break;
	case 8 * 12:
	    /* W */
		player->lx = PLAYER_START_X * 65536;
		player->ly = PLAYER_START_Y * 65536;
		player->status = PLAYER_STATUS_APPEAR;	/* oԂ */
		player->counter = 0;
#if	0
		player->rest--;
		if (player->rest <= 0) {
			player->game_over = GAME_OVER;
		} else {
			if (!eshot_erase)
				eshot_erase = ESHOT_ERASE;	/* e */
		}
		DispRest ();	/* c@\ */
#endif
		break;

	default:
		if (player->counter < 55)
			xobj_set_st (player);	/* @\ */
		break;
	}
}



/* @񂾌̓oꏈ */
static void PlayerMoveAppear (void)
{
	player->bank = 0;
	player->pt = obj_player + PLAYER_PT_CENTER;
	player->ly -= (4 * 65536);

	player->x = player->lx / 65536;
	player->y = player->ly / 65536;

    /* @x܂Ői񂾂ʏԂ */
	if (player->y < 160) {
		player->status = PLAYER_STATUS_ALIVE;
		player->muteki = TIME_MUTEKI;
	}
	player->info = PALET_PLAYER | PRIORITY_PLAYER;
	if (player->flash++ > 1) {
		player->info = PALET_PLAYER_FLASH | PRIORITY_PLAYER;
		player->flash = 0;
	}
	xobj_set_st (player);	/* @\ */
}



/* ƂɌĂ΂ */
void PlayerMove (void)
{
	switch (player->status) {
	case PLAYER_STATUS_ALIVE:
		PlayerMoveAlive ();
		break;
	case PLAYER_STATUS_DEAD:
		PlayerMoveDead ();
		break;
	case PLAYER_STATUS_APPEAR:
		PlayerMoveAppear ();
		break;
	}
}
